function [bboxes] = linesClassifer(Image,boxes,lClassifier)

% lines filtering 

cellSize = [4 4];
bboxes = [];
[rows,cols] = size(boxes);

for i = 1:rows
    
    box = boxes(i,:);
    I2 = imcrop(Image,box);
    resized = imresize(I2,[46,170]);
    
    testFeatures = extractHOGFeatures(resized,'CellSize',cellSize);
 

    % Make class predictions using the test features.
    predictedLabels = predict(lClassifier, testFeatures);
    
    if (double(predictedLabels(:)) == 1)
        bboxes(i,:) = boxes(i,:);
    end
    
end

bboxes( ~any(bboxes,2), : ) = [];  %%%%% 

[r,c] = size(bboxes);
if (r == 0)
    bboxes = boxes;
else
    bboxes = bboxes;
end

end