function [textBBoxes] = mergeBBoxes(BBoxes)

% Merge Horizantle & overlap Bounding Boxes 

% Finding centers
xmin = BBoxes(:,1);
ymin = BBoxes(:,2);
xmax = xmin + BBoxes(:,3) - 1;
ymax = ymin + BBoxes(:,4) - 1;

Xcen = (xmax(:) + xmin(:))/2;
Ycen = (ymax(:) + ymin(:))/2;
% centers = [Xcen,Ycen];
len = length(Xcen);
Y_diff = zeros(len,len);
X_diff = zeros(len,len);

for i = 1:len
    for j =1:len
        Y_diff(i,j) = abs(Ycen(i)-Ycen(j));
        X_diff(i,j) = abs(Xcen(i)-Xcen(j));
    end
end

selected = [];
BoundingBox = [];
k = 1;

for m = 1:len
    for n = 1:len
        minimum = min(BBoxes(n,4),BBoxes(m,4))/1.3;
        minim  = min(BBoxes(n,4),BBoxes(m,4));
        maxim = max(BBoxes(n,4),BBoxes(m,4));
        minimum_width = min(BBoxes(n,3),BBoxes(m,3));
        maximum_width = max(BBoxes(n,3),BBoxes(m,3))/2;
        if ( m < n && maxim < 2*minim )
            if (Y_diff(n,m) < minimum && X_diff(n,m) < (maximum_width+minimum_width))
                selected(k,:) = [xmin(n),xmin(m),ymin(n),ymin(m),xmax(n),xmax(m),ymax(n),ymax(m)];
                k = k+1;
            else
%                 selected(k,:) = [xmin(n),xmin(m),ymin(n),ymin(m),xmax(n),xmax(m),ymax(n),ymax(m)];
%                 k = k+1;
                  continue;
            end
        else
            continue;
        end
    end
end

[rows, cols] = size(selected);

if (rows == 0 && cols ==0)
    BoundingBox = [xmin, ymin, xmax, ymax];
else
    for i =1:length(selected(:,1))
        BoundingBox(i,:) = [min(selected(i,(1:2))), min(selected(i,(3:4))), ...
                            max(selected(i,(5:6))), max(selected(i,(7:8)))];
    end
end


xxmin1 = BoundingBox(:,1);
yymin1 = BoundingBox(:,2);
xxmax1 = BoundingBox(:,3);
yymax1 = BoundingBox(:,4);

boundingBoxes = [xxmin1 yymin1 xxmax1-xxmin1+1 yymax1-yymin1+1;xmin ymin xmax-xmin+1 ymax-ymin+1];


xmin2 = boundingBoxes(:,1);
ymin2 = boundingBoxes(:,2);
xmax2 = xmin2 + boundingBoxes(:,3) - 1;
ymax2 = ymin2 + boundingBoxes(:,4) - 1;

width = xmax2 - xmin2 + 1;
height = ymax2 - ymin2 + 1;
% Show the expanded bounding boxes
expandedBBoxes = [xmin2 ymin2 width height];

% Compute the overlap ratio
overlapRatio = bboxOverlapRatio(expandedBBoxes, expandedBBoxes,'min');

% Set the overlap ratio between a bounding box and itself to zero to
% simplify the graph representation.

n = size(overlapRatio,1); 
overlapRatio(1:n+1:n^2) = 0;

% made the weigths zero if they are less than 0.85
indices = find(overlapRatio < 0.8);
overlapRatio(indices) = 0;

% Create the graph
g = graph(overlapRatio);

% Find the connected text regions within the graph
componentIndices = conncomp(g);

% Merge the boxes based on the minimum and maximum dimensions.
xmin2 = accumarray(componentIndices', xmin2, [], @min);
ymin2 = accumarray(componentIndices', ymin2, [], @min);
xmax2 = accumarray(componentIndices', xmax2, [], @max);
ymax2 = accumarray(componentIndices', ymax2, [], @max);

% Compose the merged bounding boxes using the [x y width height] format.
textBBoxes = [xmin2 ymin2 xmax2-xmin2+1 ymax2-ymin2+1];


% Remove bounding boxes that only contain one text region
% numRegionsInGroup = histcounts(componentIndices);
% textBBoxes(numRegionsInGroup == 1, :) = [];


end

%