function [bboxes] = svmClassifier(Image,boxes)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Classify regions based on trained SVM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% K-means clustring features extraction from adam coats and and andrew anji 
% TRAINING_DIR ='E:\Study Data\Dataset\Training Data\Kmeans_demos';

%% define trained parameters

rfSize = 7;
TRAINING_DIM=[42 46 3];

A = matfile('centroids.mat');
centroids = A.centroids;

B = matfile('theta.mat');
theta = B.theta;

C = matfile('M.mat');
M = C.M;

D = matfile('P.mat');
P = D.P;

E = matfile('trainXC_mean.mat');
trainXC_mean = E.trainXC_mean;

F = matfile('trainXC_sd.mat');
trainXC_sd = F.trainXC_sd;

% 
% save('centroids.mat','centroids')
% save('theta.mat','theta')
% save('M.mat','M')
% save('P.mat','P')
% save('trainXC_mean.mat','trainXC_mean')
% save('trainXC_sd.mat','trainXC_sd')

%% test data

bboxes = [];
n = 1;
for i = 1:length(boxes)
    
    box = boxes(i,:);
    I2 = imcrop(Image,box);
    resized = imresize(I2,[42,46]);
    testX = double(reshape(resized,1,[]));
    
    % compute testing features and standardize
    testXC = extract_features(testX, centroids, rfSize, TRAINING_DIM, M,P);
    testXCs = bsxfun(@rdivide, bsxfun(@minus, testXC, trainXC_mean), trainXC_sd);
    testXCss = [testXCs, ones(size(testXCs,1),1)];
    
    % test and print result
    [val,labels] = max(testXCss*theta, [], 2);
    
    
    if labels == 2
        bboxes(i,:) = boxes(i,:);
    end
    
end
bboxes( ~any(bboxes,2), : ) = [];
end

