function  [classifier] = svm_Hog()
warning off;

dir = 'C:\Users\Zia Khan\Desktop\Dataset of Urdu text in scene images\Training Dataset\54x220 Training Lines';
trainingSet = imageDatastore(dir,   'IncludeSubfolders', true, 'LabelSource', 'foldernames');

img = readimage(trainingSet, 206);

% Extract HOG features
[hog_4x4] = extractHOGFeatures(img,'CellSize',[4 4]);

cellSize = [4 4];
hogFeatureSize = length(hog_4x4);

numImages = numel(trainingSet.Files);
trainingFeatures = zeros(numImages, hogFeatureSize, 'single');


for i = 1:numImages

    i
    img = readimage(trainingSet, i);
    
    img = rgb2gray(img);
    
    % Apply pre-processing steps
    % img = imbinarize(img);
    
    trainingFeatures(i, :) = extractHOGFeatures(img, 'CellSize', cellSize);  
end

% Get labels for each image.
trainingLabels = trainingSet.Labels;

% fitcecoc uses SVM learners and a 'One-vs-One' encoding scheme.
classifier = fitcecoc(trainingFeatures, trainingLabels)

end


